import java.net.*;
import java.io.*;
JSONArray items;
String result;
PImage chicago;
float diameter;


void setup() {
  size(700, 1090);
  result   = getUrlContents("http://www.divvybikes.com/stations/json");
  //textAlign(CENTER, CENTER);
  chicago = loadImage("chitown.jpg");
}


void draw() {
  background(127);
  image(chicago, 0, 0, width, height);
  stroke(1);
  fill(255, 0, 0, 25);
  JSONObject stations = JSONObject.parse(result);
  JSONArray items = stations.getJSONArray("stationBeanList");


  for (int i = 0; i < items.size (); i++) {

    JSONObject stationInfo = items.getJSONObject(i); 
    String stationName = stationInfo.getString("stationName");
    int totalDocks = stationInfo.getInt("totalDocks");
    int availableBikes = stationInfo.getInt("availableBikes");
    float longitude = stationInfo.getFloat("longitude");
    float latitude = stationInfo.getFloat("latitude");
    float lon = map(longitude, -87.76, -87.58, 0, width);
    float lat = map(latitude, 41.99, 41.78, 0, height);
    diameter = availableBikes*2;

    //noStroke();

    if (availableBikes > 12) {
      fill(50, 220, 255);
    } else if (availableBikes > 7 && availableBikes < 14) {
      fill(255, 255, 31, 145);
    } else {
      fill(255, 0, 0, 80);
    }
    ellipse(lon, lat, diameter, diameter);
  }

  for (int i = 0; i < items.size (); i++) {

    JSONObject stationInfo = items.getJSONObject(i); 
    String stationName = stationInfo.getString("stationName");
    int totalDocks = stationInfo.getInt("totalDocks");
    int availableBikes = stationInfo.getInt("availableBikes");
    float longitude = stationInfo.getFloat("longitude");
    float latitude = stationInfo.getFloat("latitude");
    float lon = map(longitude, -87.76, -87.58, 0, width);
    float lat = map(latitude, 41.99, 41.78, 0, height);
    //instead of availableBikes*2, we want to be more refined
    //for our hover
    diameter = availableBikes;

    if (dist(mouseX, mouseY, lon, lat) < diameter) {
      fill(0);
      textSize(14);
      //we draw our text more centered over the ellipse
      //by subtracting pixels from where it's drawn. 
      text(stationName+" Bikes: "+availableBikes, lon-120, lat-10);
    }







    // I wanted to make this conditional show bike info on left side of ellipse when in the lower right area of map




//    if (dist(mouseX, mouseY, lon, lat) < diameter && mouseX > width/2 && mouseY > height/2) {
//      fill(0);
//      textSize(14);
//      text(stationName+" Bikes: "+availableBikes, lon+diameter/2, lat-diameter/2);
//    }












  }
}

